/**
 * DsmlAttr.java
 * <p>
 * File generated from the core::DsmlAttr uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import net.ihe.gazelle.hpd.gui.DsmlAttrValue;
import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class DsmlAttr.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "DsmlAttr", propOrder = {
        "value",
        "name"
})
@XmlRootElement(name = "DsmlAttr")
public class DsmlAttr extends net.ihe.gazelle.gen.common.CommonOperations implements java.io.Serializable {

    /**
     *
     */
    private static final long serialVersionUID = 1L;


    @XmlElement(name = "value", namespace = "urn:oasis:names:tc:DSML:2:0:core")
    public List<String> value;
    @XmlAttribute(name = "name", required = true)
    public String name;
    @XmlTransient
    private Object _parent;
    @XmlTransient
    private List<DsmlAttrValue> valuesForGui;

    void afterUnmarshal(javax.xml.bind.Unmarshaller u, Object parent) {
        this._parent = parent;
    }

    /**
     * An attribute containing marshalled element node
     */
    @XmlTransient
    private org.w3c.dom.Node _xmlNodePresentation;

    public DsmlAttr() {

    }

    public DsmlAttr(String name) {
        this.name = name;
    }

    public DsmlAttr(String name, String inValue) {
        this.name = name;
        this.addValueForGui(inValue);
    }

    /**
     * Return value.
     * @return value
     */
    public List<String> getValue() {
        if (value == null) {
            value = new ArrayList<String>();
        }
        return value;
    }

    /**
     * Set a value to attribute value.
     * @param value.
     */
    public void setValue(List<String> value) {
        this.value = value;
    }


    /**
     * Add a value to the value collection.
     * @param value_elt Element to add.
     */
    public void addValue(String value_elt) {
        this.getValue().add(value_elt);
    }

    /**
     * Remove a value to the value collection.
     * @param value_elt Element to remove
     */
    public void removeValue(String value_elt) {
        this.getValue().remove(value_elt);
    }

    /**
     * Return name.
     * @return name
     */
    public String getName() {
        return name;
    }

    /**
     * Set a value to attribute name.
     * @param name.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Return _parent.
     * @return _parent
     */
    public Object get_parent() {
        return _parent;
    }

    /**
     * Set a value to attribute _parent.
     * @param _parent.
     */
    public void set_parent(Object _parent) {
        this._parent = _parent;
    }


    public Node get_xmlNodePresentation() {
        if (_xmlNodePresentation == null) {
            JAXBContext jc;
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            dbf.setNamespaceAware(true);
            DocumentBuilder db = null;
            Document doc = null;
            try {
                db = dbf.newDocumentBuilder();
                doc = db.newDocument();
            } catch (ParserConfigurationException e1) {
            }
            try {
                jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
                Marshaller m = jc.createMarshaller();
                m.marshal(this, doc);
                _xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "DsmlAttr").item(0);
            } catch (JAXBException e) {
                try {
                    db = dbf.newDocumentBuilder();
                    _xmlNodePresentation = db.newDocument();
                } catch (Exception ee) {
                }
            }
        }
        return _xmlNodePresentation;
    }

    public void set_xmlNodePresentation(Node _xmlNodePresentation) {
        this._xmlNodePresentation = _xmlNodePresentation;
    }


    /**
     * Description of the method getPartFromValue.
     *
     * @param value
     * @param partId
     * @return ret
     */
    public String getPartFromValue(String value, Integer partId) {
        if (partId == null || value == null) {
            return null;
        }
        java.util.regex.Pattern pat = java.util.regex.Pattern.compile("^([^:]*):?([^:]*):?([^:]*):?([^:]*):?([^:]*)$");
        java.util.regex.Matcher mat = pat.matcher(value);
        while (mat.find()) {
            if (mat.groupCount() >= partId) {
                return mat.group(partId);
            }
        }
        return null;
    }


    /**
     * validate by a module of validation
     *
     */
    public static void validateByModule(DsmlAttr dsmlAttr, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation
            .Notification> diagnostic) {
        if (dsmlAttr != null) {
            cvm.validate(dsmlAttr, _location, diagnostic);
        }
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof DsmlAttr)) {
            return false;
        }

        DsmlAttr dsmlAttr = (DsmlAttr) o;

        if (value != null ? !value.equals(dsmlAttr.value) : dsmlAttr.value != null) {
            return false;
        }
        return name != null ? name.equals(dsmlAttr.name) : dsmlAttr.name == null;
    }

    @Override
    public int hashCode() {
        int result = value != null ? value.hashCode() : 0;
        result = 31 * result + (name != null ? name.hashCode() : 0);
        return result;
    }

    public List<DsmlAttrValue> getValuesForGui() {
        if (valuesForGui == null) {
            valuesForGui = new ArrayList<DsmlAttrValue>();
        }
        return valuesForGui;
    }

    public void addValueForGui(String newValue){
        getValuesForGui().add(new DsmlAttrValue(newValue));
    }

    public void removeValueForGui(DsmlAttrValue attrValue){
        getValuesForGui().remove(attrValue);
    }

    public void setValuesForGui(List<DsmlAttrValue> valuesForGui) {
        this.valuesForGui = valuesForGui;
    }

    public void setValuesForGuiFromValue() {
        for (String val : getValue()) {
            getValuesForGui().add(new DsmlAttrValue(val));
        }
    }

    public void setAttrValueFromGui(){
        for (DsmlAttrValue val: getValuesForGui()){
            addValue(val.getGuiValue());
        }
    }
}